/**
	************************************************************
	************************************************************
	************************************************************
	*	ļ 	delay.c
	*
	*	ߣ 		ż
	*
	*	ڣ 		2017-01-23
	*
	*	汾 		V1.0
	*
	*	˵ 		Timer6ʽʱ
	*
	*	޸ļ¼	
	************************************************************
	************************************************************
	************************************************************
**/

//Ƭͷļ
#include "stm32f10x.h"

//delayͷļ
#include "delay.h"



//ʱϵ
unsigned char UsCount = 0;
unsigned short MsCount = 0;



/*
************************************************************
*	ƣ	Delay_Init
*
*	ܣ	systickʼ
*
*	ڲ	
*
*	ز	
*
*	˵		
************************************************************
*/
void Delay_Init(void)
{

	RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM6, ENABLE);

	TIM6->CR1 |= 1UL << 3;									//ģʽ
	
	TIM6->EGR |= 1;											//
	
	TIM6->DIER = 0;											//ֹж
	
	TIM6->CR1 &= (unsigned short)~TIM_CR1_CEN;				//ֹͣʱ

}

/*
************************************************************
*	ƣ	DelayUs
*
*	ܣ	΢뼶ʱ
*
*	ڲ	usʱʱ
*
*	ز	
*
*	˵		ʱ(21MHz)ʱ798915us
************************************************************
*/
void DelayUs(unsigned short us)
{

	TIM6->ARR = us;
	
	TIM6->PSC = 71;									//timer6Ϊ72MHzΪ71+1Ƶ1MHz1usһ
	
	TIM6->CR1 |= (unsigned short)TIM_CR1_CEN;		//ʼʱ
	
	while(!(TIM6->SR & 1));							//ȴж¼
	
	TIM6->SR &= ~(1UL << 0);						//־

}

/*
************************************************************
*	ƣ	DelayXms
*
*	ܣ	뼶ʱ
*
*	ڲ	msʱʱ
*
*	ز	
*
*	˵		
************************************************************
*/
void DelayXms(unsigned short ms)
{

	if(ms < 32768)
	{
		TIM6->ARR = (ms << 1);						//˫ֵ
		
		TIM6->PSC = 35999;							//timer6Ϊ72MHzΪ35999+1Ƶ2KHz500usһ
		
		TIM6->CR1 |= (unsigned short)TIM_CR1_CEN;	//ʼʱ
		
		while(!(TIM6->SR & 1));						//ȴж¼
		
		TIM6->SR &= ~(1UL << 0);					//־
	}

}

/*
************************************************************
*	ƣ	DelayMs
*
*	ܣ	΢뼶ʱ
*
*	ڲ	msʱʱ
*
*	ز	
*
*	˵		εDelayXmsʱ
************************************************************
*/
void DelayMs(unsigned short ms)
{

	unsigned char repeat = 0;
	unsigned short remain = 0;
	
	repeat = ms / 500;
	remain = ms % 500;
	
	while(repeat)
	{
		DelayXms(500);
		repeat--;
	}
	
	if(remain)
		DelayXms(remain);

}
