/**
	************************************************************
	************************************************************
	************************************************************
	*	ļ 	adxl345.c
	*
	*	ߣ 		ż
	*
	*	ڣ 		2016-11-23
	*
	*	汾 		V1.0
	*
	*	˵ 		ADXL345ʼȡֵ
	*
	*	޸ļ¼	
	************************************************************
	************************************************************
	************************************************************
**/

//Ƭͷļ
#include "stm32f10x.h"

//Ӳ
#include "adxl345.h"
#include "i2c.h"
#include "delay.h"



ADXL345_INFO adxlInfo;



/*
************************************************************
*	ƣ	ADXL345_Init
*
*	ܣ	ADXL345ʼ
*
*	ڲ	
*
*	ز	
*
*	˵		
************************************************************
*/
void ADXL345_Init(void)
{
	
    unsigned char devid = 0, val = 0;

    DelayUs(300);

    I2C_ReadByte(ADXL345_ADDRESS, 0x00, &devid);			//ID	ÿζд֮ǰҪID
	DelayUs(300);

	val = 0x2B;
    I2C_WriteByte(ADXL345_ADDRESS, DATA_FORMAT_REG, &val);	//͵ƽж,13λȫֱ,Ҷ,16g
	DelayUs(50);
    
	val = 0x0A;
    I2C_WriteByte(ADXL345_ADDRESS, BW_RATE, &val);			//ٶΪ100Hz
	DelayUs(50);
    
	val = 0x28;
    I2C_WriteByte(ADXL345_ADDRESS, POWER_CTL, &val);		//ʹ,ģʽ
	DelayUs(50);
    
	val = 0;
    I2C_WriteByte(ADXL345_ADDRESS, INT_ENABLE, &val);		//ʹж
	DelayUs(50);
    
    I2C_WriteByte(ADXL345_ADDRESS, OFSX, &val);				//Xƫ0
	DelayUs(50);
    
    I2C_WriteByte(ADXL345_ADDRESS, OFSY, &val);				//Yƫ0
	DelayUs(50);
    
    I2C_WriteByte(ADXL345_ADDRESS, OFSZ, &val);				//Zƫ0
	
    DelayUs(500);

}

/*
************************************************************
*	ƣ	ADXL345_GetValue
*
*	ܣ	ȡADXL345ֵ
*
*	ڲ	
*
*	ز	
*
*	˵		adxl345ṹ
************************************************************
*/
void ADXL345_GetValue(void)
{

	unsigned char devid = 0;
	
	unsigned char dataTemp[6];
	
	IIC_SpeedCtl(5);													//IICٶ

    DelayUs(200);
    I2C_ReadByte(ADXL345_ADDRESS, 0x00, &devid);						//ID	ÿζд֮ǰҪID
	DelayUs(200);
	
	I2C_ReadBytes(ADXL345_ADDRESS, 0x32, dataTemp, 6);					//ȡԭʼֵ(4mg/LSB)
	
	adxlInfo.incidence_X = (short)(dataTemp[0] + ((unsigned short)dataTemp[1] << 8));
    adxlInfo.incidence_Y = (short)(dataTemp[2] + ((unsigned short)dataTemp[3] << 8));
    adxlInfo.incidence_Z = (short)(dataTemp[4] + ((unsigned short)dataTemp[5] << 8));
	
	adxlInfo.incidence_Xf = (float)adxlInfo.incidence_X * 0.0039;		//Ϊg
	adxlInfo.incidence_Yf = (float)adxlInfo.incidence_Y * 0.0039;		//ÿһLSB3.9mg
	adxlInfo.incidence_Zf = (float)adxlInfo.incidence_Z * 0.0039;		//жٸLSBͳ0.0039g͵õgΪλļֵ

}
