/**
	************************************************************
	************************************************************
	************************************************************
	*	ļ 	hwtimer.c
	*
	*	ߣ 		ż
	*
	*	ڣ 		2016-11-23
	*
	*	汾 		V1.0
	*
	*	˵ 		Ƭʱʼ
	*
	*	޸ļ¼	
	************************************************************
	************************************************************
	************************************************************
**/

//Ӳ
#include "hwtimer.h"







/*
************************************************************
*	ƣ	Timer1_8_Init
*
*	ܣ	Timer18PWM
*
*	ڲ	TIMxTIM1  TIM8
*				arrֵ
*				pscƵֵ
*
*	ز	
*
*	˵		
************************************************************
*/
void Timer1_8_Init(TIM_TypeDef * TIMx, unsigned short arr, unsigned short psc)
{
	
	GPIO_InitTypeDef gpioInitStruct;
	TIM_TimeBaseInitTypeDef timerInitStruct;
	TIM_OCInitTypeDef timerOCInitStruct;

	if(TIMx == TIM1)
	{
		RCC_APB2PeriphClockCmd(RCC_APB2Periph_TIM1, ENABLE);
	}
	else
	{
		RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOC, ENABLE);
		RCC_APB2PeriphClockCmd(RCC_APB2Periph_TIM8, ENABLE);
	}
	
	gpioInitStruct.GPIO_Mode = GPIO_Mode_AF_PP;
	gpioInitStruct.GPIO_Pin = GPIO_Pin_7 | GPIO_Pin_8;
	gpioInitStruct.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOC, &gpioInitStruct);	
	
	timerInitStruct.TIM_ClockDivision = TIM_CKD_DIV1;
	timerInitStruct.TIM_CounterMode = TIM_CounterMode_Up;
	timerInitStruct.TIM_Period = arr;
	timerInitStruct.TIM_Prescaler = psc;
	TIM_TimeBaseInit(TIMx, &timerInitStruct);
	
	timerOCInitStruct.TIM_OCMode = TIM_OCMode_PWM2;				//ѡʱģʽ:TIMȵģʽ2
 	timerOCInitStruct.TIM_OutputState = TIM_OutputState_Enable; //Ƚʹ
	timerOCInitStruct.TIM_OCPolarity = TIM_OCPolarity_Low;		//:TIMȽϼԵ
	timerOCInitStruct.TIM_Pulse = 0;
	TIM_OC2Init(TIMx, &timerOCInitStruct);
	TIM_OC3Init(TIMx, &timerOCInitStruct);
	
	TIM_CtrlPWMOutputs(TIMx, ENABLE);							//MOE ʹ	
	
	TIM_OC2PreloadConfig(TIMx, TIM_OCPreload_Enable);			//ʹTIMxCCR1ϵԤװؼĴ
	TIM_OC3PreloadConfig(TIMx, TIM_OCPreload_Enable);			//ʹTIMxCCR1ϵԤװؼĴ
 
	TIM_ARRPreloadConfig(TIMx, ENABLE);							//ARPEʹ
	
	TIM_Cmd(TIMx, ENABLE);										//ʹTIMx

}

/*
************************************************************
*	ƣ	Timer6_7_Init
*
*	ܣ	Timer67Ķʱ
*
*	ڲ	TIMxTIM6  TIM7
*				arrֵ
*				pscƵֵ
*
*	ز	
*
*	˵		timer6timer7ֻижϹ
************************************************************
*/
void Timer6_7_Init(TIM_TypeDef * TIMx, unsigned short arr, unsigned short psc)
{

	TIM_TimeBaseInitTypeDef timerInitStruct;
	NVIC_InitTypeDef nvicInitStruct;
	
	if(TIMx == TIM6)
	{
		RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM6, ENABLE);
		
		nvicInitStruct.NVIC_IRQChannel = TIM6_IRQn;
	}
	else
	{
		RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM7, ENABLE);
		
		nvicInitStruct.NVIC_IRQChannel = TIM7_IRQn;
	}
	
	timerInitStruct.TIM_CounterMode = TIM_CounterMode_Up;
	timerInitStruct.TIM_Period = arr;
	timerInitStruct.TIM_Prescaler = psc;
	
	TIM_TimeBaseInit(TIMx, &timerInitStruct);
	
	TIM_ITConfig(TIMx, TIM_IT_Update, ENABLE);					//ʹܸж
	
	nvicInitStruct.NVIC_IRQChannelCmd = ENABLE;
	nvicInitStruct.NVIC_IRQChannelPreemptionPriority = 1;
	nvicInitStruct.NVIC_IRQChannelSubPriority = 1;
	
	NVIC_Init(&nvicInitStruct);
	
	TIM_Cmd(TIMx, ENABLE); //ʹܶʱ

}

/*
************************************************************
*	ƣ	TIM6_IRQHandler
*
*	ܣ	RTOSʱж
*
*	ڲ	
*
*	ز	
*
*	˵		
************************************************************
*/
extern void xPortSysTickHandler(void);
void TIM6_IRQHandler(void)
{

	if(TIM_GetITStatus(TIM6, TIM_IT_Update) == SET)
	{
		//do something...
		
		TIM_ClearITPendingBit(TIM6, TIM_IT_Update);
	}

}

/*
************************************************************
*	ƣ	TIM7_IRQHandler
*
*	ܣ	Timer7жϷ
*
*	ڲ	
*
*	ز	
*
*	˵		
************************************************************
*/
void TIM7_IRQHandler(void)
{

	if(TIM_GetITStatus(TIM7, TIM_IT_Update) == SET)
	{
		TIM_ClearITPendingBit(TIM7, TIM_IT_Update);
	}

}
