/**
	************************************************************
	************************************************************
	************************************************************
	*	ļ 	led.c
	*
	*	ߣ 		ż
	*
	*	ڣ 		2016-11-23
	*
	*	汾 		V1.0
	*
	*	˵ 		LEDʼLED
	*
	*	޸ļ¼	
	************************************************************
	************************************************************
	************************************************************
**/

//Ƭͷļ
#include "stm32f10x.h"

//LEDͷļ
#include "led.h"




LED_STATUS ledStatus;


/*
************************************************************
*	ƣ	Led_Init
*
*	ܣ	LEDʼ
*
*	ڲ	
*
*	ز	
*
*	˵		LED4-PC7	LED5-PC8	LED6-PA12	LED7-PC10
				ߵƽص		͵ƽ
************************************************************
*/
void Led_Init(void)
{
	
	GPIO_InitTypeDef gpioInitStrcut;

	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA | RCC_APB2Periph_GPIOC, ENABLE);
	
	gpioInitStrcut.GPIO_Mode = GPIO_Mode_Out_PP;
	gpioInitStrcut.GPIO_Pin = GPIO_Pin_7 | GPIO_Pin_8 |GPIO_Pin_10;
	gpioInitStrcut.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOC, &gpioInitStrcut);
	
	gpioInitStrcut.GPIO_Pin = GPIO_Pin_12;
	GPIO_Init(GPIOA, &gpioInitStrcut);
    
    Led4_Set(LED_OFF);
    Led5_Set(LED_OFF);
    Led6_Set(LED_OFF);
    Led7_Set(LED_OFF);

}

/*
************************************************************
*	ƣ	Led4_Set
*
*	ܣ	LED4
*
*	ڲ	statusLED_ON-	LED_OFF-ص
*
*	ز	
*
*	˵		
************************************************************
*/
void Led4_Set(LED_ENUM status)
{

	GPIO_WriteBit(GPIOC, GPIO_Pin_7, status != LED_ON ? Bit_SET : Bit_RESET);
	ledStatus.Led4Sta = status;

}

/*
************************************************************
*	ƣ	Led5_Set
*
*	ܣ	LED5
*
*	ڲ	statusLED_ON-	LED_OFF-ص
*
*	ز	
*
*	˵		
************************************************************
*/
void Led5_Set(LED_ENUM status)
{

	GPIO_WriteBit(GPIOC, GPIO_Pin_8, status != LED_ON ? Bit_SET : Bit_RESET);
	ledStatus.Led5Sta = status;

}

/*
************************************************************
*	ƣ	Led6_Set
*
*	ܣ	LED6
*
*	ڲ	statusLED_ON-	LED_OFF-ص
*
*	ز	
*
*	˵		
************************************************************
*/
void Led6_Set(LED_ENUM status)
{

	GPIO_WriteBit(GPIOA, GPIO_Pin_12, status != LED_ON ? Bit_SET : Bit_RESET);
	ledStatus.Led6Sta = status;

}

/*
************************************************************
*	ƣ	Led7_Set
*
*	ܣ	LED7
*
*	ڲ	statusLED_ON-	LED_OFF-ص
*
*	ز	
*
*	˵		
************************************************************
*/
void Led7_Set(LED_ENUM status)
{

	GPIO_WriteBit(GPIOC, GPIO_Pin_10, status != LED_ON ? Bit_SET : Bit_RESET);
	ledStatus.Led7Sta = status;

}
